*:*********************************************************************
*:
*:        Program: CODE39.PRG
*:
*:         System:                                         
*:         Author:                                         
*:      Copyright (c) 1989,                                         
*:  Last modified: 05/06/88     15:05
*:
*:  Procs & Fncts: SETUP_HP
*:               : SETUP_EPSON
*:               : DEF_CODE39
*:               : BARCODE()
*:               : PRINTCODE()
*:
*:          Calls: SETUP_HP         (procedure in CODE39.PRG)
*:               : SETUP_EPSON      (procedure in CODE39.PRG)
*:               : DEF_CODE39       (procedure in CODE39.PRG)
*:
*:     Documented: 11/05/89 at 03:30                SNAP! version 3.10
*:*********************************************************************
**************************************************************************
* Program...: CODE39.PRG
* Version...: 1.0
* Function..: Prints 3 of 9 barcodes
*
* Source....: Clipper (Summer '87)
* Libraries.: CLIPPER.LIB  (c) Nantucket Corporation (Summer '87)
*             EXTEND.LIB   (c) Nantucket Corporation (Summer '87)
*
* Author....: George T. Neill
*             2140 Main Street
*             La Crosse, WI  54601
*
* Created...: May 5, 1988  at 10:21 am
* Copyright.: None, released to the public domain as is with no express
*             or implied warranty as to suitability or accuracy of this
*             program.  The author shall not be held liable for any 
*             damages, either direct or non-direct, arising from the use
*             of this program.  This program may be modified and/or
*             included in any program without any consideration to the
*             author.
**************************************************************************
* Revisions:
* Date        Time   Who   Change Description
* -
*
**************************************************************************
**************************************************************************
*****                 CODE 3-of-9 BAR CODE  GENERATOR                *****
*****                 *******************************                *****
*****      This program will generate standard 3-of-9 bar code       *****
*****      on any dot matrix printer which is compatable with        *****
*****      an Epson/IBM graphics printer or HP LaserJet.             *****
*****                 ******************************                 *****
*****                      -  SPECIFICATIONS -                       *****
**                                                                      **
**                         W                                 N          **
**                |  Nominal Width  | Nominal Width  | Nominal Ratio    **
**     Density    |       of        |      of        |      of          **
**   (Characters/ | Narrow Bars and | Wide Bars and  | Wide to Narrow   **
**      Inch)     | Spaces (Inches) | Spaces (Inches)| Element Width    **
**   -------------+-----------------+----------------+----------------  **
**      5.730     |     0.0125      |     0.0315     |      2.52        **
**   -------------+-----------------+----------------+----------------  **
**                                                                      **
*****                 ******************************                 *****
*****  Code 3-of-9 was developed in 1974 by Dr. David C. Allais of   *****
*****  Interface Mechanisms, Inc.  It has been adopted as the        *****
*****  standard bar code symbology of the Department of Defence      *****
*****  (MIL-STD-1189) and is the most widely used alphanumeric bar   *****
*****  code in use.  Code 3-of-9 is so called because the original   *****
*****  concept provided for 39 data characters.  The name also       *****
*****  describes the structure of the code which has 3 wide elements *****
*****  out of a total of 9.                                          *****
*****                                                                *****
*****  This program was written solely for information purposes to   *****
*****  demonstrate the structure of code 3-of-9.  The author is      *****
*****  not responsible for any damages incurred through the use of   *****
*****  this program.                                                 *****
*****                                                                *****
*****                           Bill Wood  Milwaukee, WI   05/18/85  *****
**************************************************************************
**************************************************************************
*****                                                                *****
*****  This dBase code originated from a basic program written by    *****  
*****  Bill Wood of Milwaukee, WI in May of 1985.  I have, of course,*****  
*****  converted it to dBase and added support for the HP LaserJet.  *****  
*****                                                                *****
*****  Because of the wide variety and quality of bar code readers   *****
*****  and barcode print quality when using a dot matrix printer, I  *****
*****  strongly recommend using a laser printer for your barcodes.   *****
*****  Also, the you will get 7 characters per inch on the laser as  *****
*****  opposed to 5.6 cpi on a dot matrix.                           *****
*****                                                                *****
*****  The LaserJet barcodes are generated using the pattern fill    *****
*****  functions and do not require the use of any font cartridges   *****
*****  or soft fonts.  The tricky part of using this method is       *****
*****  following the HP cusor location on the printed page.  Please  *****
*****  refer to the HP LaserJet Technical Reference Manual for a     *****
*****  thorough explanation of this.  Currently, the program is      *****
*****  setup to print at 6 lines per inch.  That is, a height of 1   *****
*****  is equal to one line.                                         *****
*****                                                                *****
*****  The program requires two functions, the printer setup, and    *****
*****  the barcode creation.  The printer setup defines the          *****
*****  components of the barcode and the barcode creation builds     *****
*****  the barcode from a passed character string.  Using this       *****
*****  program as an example you should be able to generate a        *****
*****  barcode routine for any printer or barcode symbology.         *****
*****                                                                *****
*****  Good Luck,                                                    *****
*****        George T. Neill                                         *****
**************************************************************************
**************************************************************************


***** Program Setup *****
CLEAR SCREEN
PUBLIC esc,null,PRINTER,height

esc = CHR(27)
null = ""

@ 01,01 SAY [Code 39 Barcode Generator]

***** get printer type *****
* default to two line LaserJet barcode
PRINTER   = "L"
height    = 2

@ 03,01 SAY [Print on (E)pson or (L)aserJet?] ;
   GET m->printer ;
   PICTURE '@!'; 
   VALID PRINTER$'EL'

@ 04,01 SAY [Enter Height of Barcode (1-4)] ;
   GET m->height ;
   PICTURE '9' ;
   RANGE 1,4
READ

IF PRINTER = "L"
   DO setup_hp
   
ELSEIF PRINTER = "E"
   DO setup_epson
   
ENDIF

***** Define CODE 3of9 Characer Set *****  
DO def_code39

***** Get text to print and print barcode *****
stay = .T.
DO WHILE stay
   ***** Create empty variable.  The length is arbitrary as there is *****
   ***** no defined maximum length of a 3of9 barcode. *****
   MESSAGE = SPACE(25)
   
   @ 07,01 SAY [Enter text to print ] ;
      GET m->message ;
      PICTURE '@K!'
   READ
   
   IF EMPTY(m->message)
      ***** exit on no message text
      stay = .F.
      LOOP
   ENDIF
   
   ***** Prepend and append required asterik's to trimmed message *****
   m->message = "*"+TRIM(m->message)+"*"
   
   SET DEVICE TO PRINT
   ***** print barcoded m->MESSAGE *****
   @ PROW()+height,00 SAY barcode(m->message)
   
   ***** Print message text below barcode *****
   @ PROW()+IF(PRINTER="L",height,0),INT(LEN(m->message)/4) SAY  m->message
   SET DEVICE TO SCREEN
   
   ***** Check for page eject *****
   ***** (necessary to see what you've done on a laserjet) *****
   EJECT = .F.
   @ 08,01 SAY [Eject?] GET EJECT PICTURE [Y]
   READ
   IF EJECT
      EJECT
   ENDIF
   
ENDDO

RETURN
***** End of File CODE39 *****


*****************
***
***   Function:  Barcode()
***    Purpose:  Creates Code39 barcode from character string
*** Parameters:  Character String
***    Returns:  String converted to barcode
***      Notes:  Requires the following variables:
***           :  
***           :      All printers:
***           :         nb = narrow bar character
***           :         wb = wide bar character
***           :         ns = narrow space
***           :         ws = wide space
***           :  
***           :      HP LaserJet:
***           :         start = Beginning cursor position adjustment
***           :         end   = Ending cursor position adjustment
***           :  
***           :      Epson/IBM Printers:
***           :         height = height of barcode in lines
***           :         n1 & n2 = calculated dot graphics length
***           :  
*****************
*!*********************************************************************
*!
*!       Function: BARCODE()
*!
*!*********************************************************************
FUNCTION barcode
PARAMETERS m->message
code = ""

DO CASE
CASE PRINTER = "L"
   * read message character at a time and build barcode
   FOR I = 1 TO LEN(m->message)
      letter = SUBSTR(m->message,I,1)
      code = code + IF(AT(letter,chars)=0,letter,char[at(letter,chars)]) + ns
   NEXT
   code = start + code + END
   
CASE PRINTER = "E"
   FOR H = 1 TO height
      FOR I = 1 TO LEN(m->message)
         letter = SUBSTR(m->message,I,1)
         
         * build barcoded string
         code = IF(AT(letter,chars)=0,letter,char[at(letter,chars)]) + ns
         
         * print barcode character at a time on Epson
         printcode(esc + CHR(76) + CHR(n1) + CHR(n2) + code)
      NEXT
      
      * perform 23/216 line feed
      printcode(esc+CHR(74)+CHR(23)+CHR(13))
   NEXT
   
   * perform 5/216 line feed
   printcode(esc+CHR(74)+CHR(5)+CHR(13))
   
   * reset printer to turn off graphics and reset to 10cpi
   printcode(esc+"@")
   
ENDCASE

RETURN code
***** End of Function(BARCODE) *****


*****************
***
***  Procedure:  Setup_HP
***    Purpose:  Defines characters for HP LaserJet
*** Parameters:  None
***    Returns:  Initialized Public variables
***
*****************

*!*********************************************************************
*!
*!      Procedure: SETUP_HP
*!
*!      Called by: CODE39.PRG     
*!
*!*********************************************************************
PROCEDURE setup_hp
PUBLIC nb,wb,ns,ws,start,END
*** define bars and spaces for HP LaserJet II
small_bar = 3                                 && number of points per bar
wide_bar = ROUND(small_bar * 2.25,0)          && 2.25 x small_bar
dpl = 50                                      && dots per line 300dpi/6lpi = 50dpl

nb = esc+"*c"+TRANSFORM(small_bar,'99')+"a"+Alltrim(STR(height*dpl))+"b0P"+esc+"*p+"+TRANSFORM(small_bar,'99')+"X"
wb = esc+"*c"+TRANSFORM(wide_bar,'99')+"a"+Alltrim(STR(height*dpl))+"b0P"+esc+"*p+"+TRANSFORM(wide_bar,'99')+"X"
ns = esc+"*p+"+TRANSFORM(small_bar,'99')+"X"
ws = esc+"*p+"+TRANSFORM(wide_bar,'99')+"X"

*** adjust cusor position to start at top of line and return to bottom of line
start = esc+"*p-50Y"
END = esc+"*p+50Y"

RETURN
***** End of Procedure(SETUP_HP) *****

*****************
***
***  Procedure:  Setup_Epson
***    Purpose:  Defines characters for Espon or IBM Graphics printer
*** Parameters:  None
***    Returns:  Initialized Public variables
***
*****************

*!*********************************************************************
*!
*!      Procedure: SETUP_EPSON
*!
*!      Called by: CODE39.PRG     
*!
*!*********************************************************************
PROCEDURE setup_epson
PUBLIC nb,wb,ns,ws,n1,n2
***** define Epson bars and spaces
ns = CHR(0) + CHR(0)
ws = CHR(0) + CHR(0) + CHR(0) + CHR(0)
nb = CHR(255)
wb = CHR(255) + CHR(255) + CHR(255)

***** set printer to 2/216 lines per inch
printcode(esc+CHR(51)+CHR(2))                 

***** calculate N1 and N2 values for dot graphics command
cols = 21
n1 = cols % 256                               && modulus 
n2 = INT(cols/256)

RETURN   
***** End of Procedure(SETUP_EPSON) *****


*****************
***
***  Procedure:  Def_Code39
***    Purpose:  Define character set for CODE39
*** Parameters:  None
***    Returns:  Initialized Public variables and array
***
*****************

*!*********************************************************************
*!
*!      Procedure: DEF_CODE39
*!
*!      Called by: CODE39.PRG     
*!
*!*********************************************************************
PROCEDURE def_code39
PUBLIC char[44], chars

chars = "1234567890ABCDEFGHIJKLMNOPQRSTUVWXYZ-. *$/+%"
char[01] = wb+ns+nb+ws+nb+ns+nb+ns+wb       && "1"
char[02] = nb+ns+wb+ws+nb+ns+nb+ns+wb       && "2"
char[03] = wb+ns+wb+ws+nb+ns+nb+ns+nb       && "3"
char[04] = nb+ns+nb+ws+wb+ns+nb+ns+wb       && "4"
char[05] = wb+ns+nb+ws+wb+ns+nb+ns+nb       && "5"
char[06] = nb+ns+wb+ws+wb+ns+nb+ns+nb       && "6"
char[07] = nb+ns+nb+ws+nb+ns+wb+ns+wb       && "7"
char[08] = wb+ns+nb+ws+nb+ns+wb+ns+nb       && "8"
char[09] = nb+ns+wb+ws+nb+ns+wb+ns+nb       && "9"
char[10] = nb+ns+nb+ws+wb+ns+wb+ns+nb       && "0"
char[11] = wb+ns+nb+ns+nb+ws+nb+ns+wb       && "A"
char[12] = nb+ns+wb+ns+nb+ws+nb+ns+wb       && "B"
char[13] = wb+ns+wb+ns+nb+ws+nb+ns+nb       && "C"
char[14] = nb+ns+nb+ns+wb+ws+nb+ns+wb       && "D"
char[15] = wb+ns+nb+ns+wb+ws+nb+ns+nb       && "E"
char[16] = nb+ns+wb+ns+wb+ws+nb+ns+nb       && "F"
char[17] = nb+ns+nb+ns+nb+ws+wb+ns+wb       && "G"
char[18] = wb+ns+nb+ns+nb+ws+wb+ns+nb       && "H"
char[19] = nb+ns+wb+ns+nb+ws+wb+ns+nb       && "I"
char[20] = nb+ns+nb+ns+wb+ws+wb+ns+nb       && "J"
char[21] = wb+ns+nb+ns+nb+ns+nb+ws+wb       && "K"
char[22] = nb+ns+wb+ns+nb+ns+nb+ws+wb       && "L"
char[23] = wb+ns+wb+ns+nb+ns+nb+ws+nb       && "M"
char[24] = nb+ns+nb+ns+wb+ns+nb+ws+wb       && "N"
char[25] = wb+ns+nb+ns+wb+ns+nb+ws+nb       && "O"
char[26] = nb+ns+wb+ns+wb+ns+nb+ws+nb       && "P"
char[27] = nb+ns+nb+ns+nb+ns+wb+ws+wb       && "Q"
char[28] = wb+ns+nb+ns+nb+ns+wb+ws+nb       && "R"
char[29] = nb+ns+wb+ns+nb+ns+wb+ws+nb       && "S"
char[30] = nb+ns+nb+ns+wb+ns+wb+ws+nb       && "T"
char[31] = wb+ws+nb+ns+nb+ns+nb+ns+wb       && "U"
char[32] = nb+ws+wb+ns+nb+ns+nb+ns+wb       && "V"
char[33] = wb+ws+wb+ns+nb+ns+nb+ns+nb       && "W"
char[34] = nb+ws+nb+ns+wb+ns+nb+ns+wb       && "X"
char[35] = wb+ws+nb+ns+wb+ns+nb+ns+nb       && "Y"
char[36] = nb+ws+wb+ns+wb+ns+nb+ns+nb       && "Z"
char[37] = nb+ws+nb+ns+nb+ns+wb+ns+wb       && "-"
char[38] = wb+ws+nb+ns+nb+ns+wb+ns+nb       && "."
char[39] = nb+ws+wb+ns+nb+ns+wb+ns+nb       && " "
char[40] = nb+ws+nb+ns+wb+ns+wb+ns+nb       && "*"
char[41] = nb+ws+nb+ws+nb+ws+nb+ns+nb       && "$"
char[42] = nb+ws+nb+ws+nb+ns+nb+ws+nb       && "/"
char[43] = nb+ws+nb+ns+nb+ws+nb+ws+nb       && "+"
char[44] = nb+ns+nb+ws+nb+ws+nb+ws+nb       && "%"

RETURN
***** End of Procedure(DEF_CODE39) *****

*****************
***
***   Function:  Printcode
***    Purpose:  Sends escape codes to printer
*** Parameters:  Character string or escape sequence
***    Returns:  Nothing
***
*****************

*!*********************************************************************
*!
*!       Function: PRINTCODE()
*!
*!*********************************************************************
FUNCTION printcode
PARAMETERS code
SET CONSOLE OFF
SET PRINT ON
?? code
SET PRINT OFF
SET CONSOLE ON
RETURN null
***** End of Function(PRINTCODE) *****

*: EOF: CODE39.PRG
